﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace UltraGridAddRowUserControl
{
    public partial class CustomControl : UserControl
    {
        #region Properties

        private DataTable dataSource;

        public DataTable DataSource
        {
            get { return dataSource; }
            set
            {
                if (value == null && value == dataSource) return;
                ultraGrid1.DataSource = value;
                dataSource = value;
            }
        }

        #endregion Properties

        #region Constructors
        public CustomControl()
        {
            InitializeComponent();
        }

        #endregion Constructors

        #region Methods
        void ultraGrid1_DoubleClick(object sender, EventArgs e)
        {
            SelectedItem();
        }

        void ultraGrid1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            SelectedItem();
        }

        void SelectedItem()
        {
            if (ultraGrid1.ActiveRow.Cells == null) return;
            ((UltraGrid)this.Parent).ActiveCell.Value = ultraGrid1.ActiveRow.Cells[0].Text; 
            this.Hide();
        }

        public void ultraTextEditor1_EditorButtonClick(object sender, Infragistics.Win.UltraWinEditors.EditorButtonEventArgs e)
        {
            ultraGrid1.DisplayLayout.Bands[0].ColumnFilters[0].FilterConditions.Clear();
            ultraGrid1.DisplayLayout.Bands[0].ColumnFilters[0].FilterConditions.Add(Infragistics.Win.UltraWinGrid.FilterComparisionOperator.Contains, ultraTextEditor1.Text);
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            SelectedItem();
        }

        #endregion Methods
    }
}
