﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;

namespace UltraGridAddRowUserControl
{
    public partial class Form1 : Form
    {
        private DataTable BookTableTitle;
        private DataTable BookTableDescription;
        private DataTable AccountFamilyTable;
        private static CustomControl cc;

        #region Constructors
        public Form1()
        {
            InitializeComponent();
            ultraCheckEditor1.Checked = true;
            cc = new CustomControl();


            #region UltraCombo - Books
            ultraCombo1.CreationFilter = new DescriptionUIElement();

            BookTableTitle = new DataTable();
            BookTableTitle.Columns.Add("Book ID", typeof(int));
            BookTableTitle.Columns.Add("Title", typeof(string));

            BookTableDescription = new DataTable();
            BookTableDescription.Columns.Add("PID", typeof(int));
            BookTableDescription.Columns.Add("Description", typeof(string));

            for (int k = 0; k < 100; k++)
            {
                BookTableTitle.Rows.Add(k, "Book Title - " + k.ToString());
                BookTableDescription.Rows.Add(k, "This is the story of my additional UltraTextEditor with description to each item from dropdown menu." + Environment.NewLine + Environment.NewLine + " Description for Item - " + k.ToString());
            }

            ultraCombo1.DataSource = BookTableTitle;
            ultraCombo1.DisplayMember = "Title";
            ultraCombo1.ValueMember = "Title";
            #endregion

            AccountFamilyTable = new DataTable();
            AccountFamilyTable.Columns.Add("Column A", typeof(string));
            AccountFamilyTable.Rows.Add("Test 1");
            AccountFamilyTable.Rows.Add("Value 2");
            AccountFamilyTable.Rows.Add("Action 3");
            AccountFamilyTable.Rows.Add("Description 4");
            AccountFamilyTable.Rows.Add("Object 5");
            AccountFamilyTable.Rows.Add("Error 6");
            AccountFamilyTable.Rows.Add("Call 7");
            AccountFamilyTable.Rows.Add("Find 8");

        }
        #endregion Constructors

        #region Methods
        private void ultraCombo1_RowSelected(object sender, Infragistics.Win.UltraWinGrid.RowSelectedEventArgs e)
        {
            if (e.Row == null) return;
            var shortlist = from q in BookTableDescription.Rows.Cast<DataRow>()
                            where q[0].ToString() == e.Row.Cells[0].Text
                            select new
                            {
                                ID = q[0],
                                Title = q[1]
                            };

            DescriptionUIElement.descUIElement.Text = shortlist.First().Title.ToString();

            ultraGrid1.ActiveRow.Cells["Book"].Value = e.Row.Cells[1].Value;
            ultraGrid1.ActiveRow.Cells["Entry Description"].Value = DescriptionUIElement.descUIElement.Text;
        }

        private void ultraCheckEditor1_CheckedChanged(object sender, EventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Book"].Hidden = !this.ultraCheckEditor1.Checked;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Currency"].Hidden = !this.ultraCheckEditor1.Checked;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Effective Date"].Hidden = !this.ultraCheckEditor1.Checked;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Base CCY Method"].Hidden = !this.ultraCheckEditor1.Checked;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Credit Control Account"].Hidden = !this.ultraCheckEditor1.Checked;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Credit Control Account Amount"].Hidden = !this.ultraCheckEditor1.Checked;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Debit Control Account"].Hidden = !this.ultraCheckEditor1.Checked;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Debit Control Account Amount"].Hidden = !this.ultraCheckEditor1.Checked;
        }

        private void ultraGrid1_BeforeEnterEditMode(object sender, CancelEventArgs e)
        {
            if (!ultraGrid1.ActiveRow.IsAddRow) e.Cancel = true;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            ValueList vl = new ValueList();
            vl.ValueListItems.Add("");

            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Credit Account"].ValueList = vl;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Debit Account"].ValueList = vl;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Credit Control Account"].ValueList = vl;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Debit Control Account"].ValueList = vl;
        }

        private void ultraGrid1_BeforeCellListDropDown(object sender, Infragistics.Win.UltraWinGrid.CancelableCellEventArgs e)
        {
            if (e.Cell.Column.Key == "Credit Account" || e.Cell.Column.Key == "Debit Account" || e.Cell.Column.Key == "Credit Control Account" || e.Cell.Column.Key == "Debit Control Account")
            {
                e.Cancel = true;
                cc.Location = new Point(e.Cell.GetUIElement().Rect.X, e.Cell.GetUIElement().Rect.Y + e.Cell.GetUIElement().Rect.Height);
                cc.Parent = ultraGrid1;
                cc.DataSource = AccountFamilyTable;
                cc.ultraTextEditor1.Text = e.Cell.Text;
                cc.ultraTextEditor1_EditorButtonClick(null, null);
                cc.Show();

            }
        }

        private void ultraGrid1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter)
            {
                ultraGrid1.UpdateData();
            }
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ultraGrid1.ActiveRow.Update();
            ultraGrid1.DisplayLayout.Bands[0].AddNew();
        }

        private void ultraGrid1_AfterRowActivate(object sender, EventArgs e)
        {
            ultraCombo1.Text = ultraGrid1.ActiveRow.Cells["Book"].Text;
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            ultraGrid1.DisplayLayout.Bands[0].AddNew();
        }
        #endregion Methods

    }
}
